Name: festival
Summary: A free speech synthesizer
Version: 1.4.2
Release: 3

# Files needed for everything...
Source: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/%{name}-%{version}-release.tar.gz
Source1: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/speech_tools-1.2.2-release.tar.gz
Source2: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festdoc-1.4.2.tar.gz
Source3: speech_tools-config
Source5: festival-config

### DICTIONARIES
# Generic English dictionary
Source100: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festlex_POSLEX.tar.gz
# American English dictionary
Source101: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festlex_CMU.tar.gz

### VOICES
# American English male speaker (KAL), residual excited LPC diphone database
Source200: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kallpc16k.tar.gz
# Same voice at lower quality
Source201: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kallpc8k.tar.gz
# American English male speaker, residual excited LPC diphone database
Source202: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kedlpc16k.tar.gz
# Same voice at lower quality
Source203: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_kedlpc8k.tar.gz
# Castilian Spanish male speaker, residual excited LPC diphone database
Source204: ftp://ftp.cstr.ed.ac.uk/pub/festival/%{version}/festvox_ellpc11k.tar.gz

# Fix up various locations to be more FSSTND compliant
Patch: festival-1.4.1-fsstnd.patch

# Set defaults to American English instead of British English - the OALD
# dictionary (free for non-commercial use only) is needed for BE support
Patch1: festival-american.patch

# Add some useful words to the dictionary...
Patch10: CMU-redhat.patch

URL: http://www.cstr.ed.ac.uk/projects/festival/
Group: Applications/Multimedia
License: BSD
BuildRoot: %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: i386
# readlink from kpathsea
BuildRequires: tetex

%package devel
Requires: %{name} = %{version}
Summary: Development files for the festival speech synthesizer
Group: Development/Libraries

%description
Festival is a general multi-lingual speech synthesis system developed
at CSTR. It offers a full text to speech system with various APIs, as
well as an environment for development and research of speech synthesis
techniques. It is written in C++ with a Scheme-based command interpreter
for general control.

%description devel
Development files for the festival speech synthesizer. Install
festival-devel if you want to use the festival speech synthesizer from
within your own progrmas and/or if you intend to compile other programs
using it.

%prep
rm -rf $RPM_BUILD_ROOT

%setup -q -n festival -a 1

tar xzf %{SOURCE2}

ln -sf festival/speech_tools ../speech_tools

%patch -p1 -b .fsstnd
#patch1 -p1 -b .americandefault

%build
export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:`pwd`/speech_tools/lib:$PATH
export PATH=`pwd`/bin:$PATH
pushd speech_tools
%configure


make

#g++ -shared -L../../../speech_tools/lib -lestools -lestbase -leststring -ltermcap -Wl,-soname -Wl,libFestival.so.1 -Wl,--rpath -Wl,/usr/lib -o ../libFestival.so.1.4.1 *

popd
%configure 
make

mkdir DATA.TMP
cd DATA.TMP
tar xzf %{SOURCE100}
tar xzf %{SOURCE101}
tar xzf %{SOURCE200}
tar xzf %{SOURCE201}
tar xzf %{SOURCE202}
tar xzf %{SOURCE203}
tar xzf %{SOURCE204}
patch -p0 <%{PATCH10}
cd festival/lib/dicts/cmu
make
cd ../../..

%install
export PATH=`pwd`/src/main:$PATH
export LD_LIBRARY_PATH=`pwd`/speech_tools/lib:$PATH
mkdir -p $RPM_BUILD_ROOT/usr/bin $RPM_BUILD_ROOT/usr/lib
pushd speech_tools
rm -f bin/Makefile
cp -a bin/* $RPM_BUILD_ROOT/usr/bin
cp -a lib/lib*.a $RPM_BUILD_ROOT/usr/lib
popd
mkdir -p $RPM_BUILD_ROOT/usr/share/festival
mv DATA.TMP/festival/lib/voices $RPM_BUILD_ROOT/usr/share/festival
mv DATA.TMP/festival/lib/dicts $RPM_BUILD_ROOT/usr/share/festival
rm -f lib/Makefile lib/*.fsstnd lib/*.americandefault bin/Makefile
mv lib/* $RPM_BUILD_ROOT/usr/share/festival
mv bin/* $RPM_BUILD_ROOT/usr/bin
# We want the real festival, not the wrapper script
rm -f $RPM_BUILD_ROOT/usr/bin/Makefile
mkdir -p $RPM_BUILD_ROOT/usr/man/man1
cp -a doc/*.1 $RPM_BUILD_ROOT/usr/man/man1

mkdir -p $RPM_BUILD_ROOT/usr/include/speech_tools
mkdir -p $RPM_BUILD_ROOT/usr/include/festival
cp -a src/include/* $RPM_BUILD_ROOT/usr/include/festival
cp -aR speech_tools/include/* $RPM_BUILD_ROOT/usr/include/speech_tools
cp -a src/lib/libFestival.a $RPM_BUILD_ROOT/usr/lib

# symlinks into buildtree evil
for i in $RPM_BUILD_ROOT/usr/bin/*; do
	if [ -h "$i" ]; then
    		a=`readlink "$i"`
		rm -f "$i"	
		cp -a "$a" $RPM_BUILD_ROOT/usr/bin/
	fi
done


# Remove some files we don't need
rm -rf $RPM_BUILD_ROOT/usr/include/speech_tools/win32
rm -rf $RPM_BUILD_ROOT/usr/include/speech_tools/Makefile
rm -rf $RPM_BUILD_ROOT/usr/include/festival/Makefile

# This shouldn't be in the tarball
pushd festdoc-1.4.2/speech_tools/doc
rm -fr CVS arch_doc/CVS man/CVS  speechtools/arch_doc/CVS
popd

# Fix up the headers to look for other includes where we want them, not
# where they're supposed to be in the source tree
# There is probably a better way to do this, I'm not (yet) a sed expert.
# What this does is, basically, replacing "EST_*.h" with <speech_tools/EST_*.h>.
for i in `find $RPM_BUILD_ROOT/usr/include/festival/ -type f` `find $RPM_BUILD_ROOT/usr/include/speech_tools/ -type f`; do
  sed -e 's,"EST.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/\",speech_tools/,g' \
	-e 's,"siod.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/\",speech_tools/,g' \
	-e 's,"instantiate/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/instantiate/\",speech_tools/instantiate/,g' -e 's,"instantiate,instantiate,g' \
	-e 's,"ling_class/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/ling_class/\",speech_tools/ling_class/,g' -e 's,"ling_class,ling_class,g'\
	-e 's,"rxp/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/rxp/\",speech_tools/rxp/,g' -e 's,"rxp,rxp,g' \
  	-e 's,"sigpr/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/sigpr/\",speech_tools/sigpr/,g' -e 's,"sigpr,sigpr,g' \
	-e 's,"unix/.*\.h",\<speech_tools/&\>,g' -e 's,speech_tools/unix/\",speech_tools/unix/,g' -e 's,\.h\">,.h\>,g' -e 's,"unix,unix,g' \
	-e 's,"festival\.h",\<festival/festival.h\>,g' \
  	-e 's,"ModuleDescription\.h",\<festival/ModuleDescription.h\>,g' \
  	-e 's,"Phone\.h",\<festival/Phone.h\>,g' $i >$i-redhat
  mv -f $i-redhat $i
done

mkdir -p $RPM_BUILD_ROOT%{_mandir}
mv $RPM_BUILD_ROOT/usr/man/* $RPM_BUILD_ROOT%{_mandir}
rm -rf $RPM_BUILD_ROOT/usr/man
rm ../speech_tools

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc ACKNOWLEDGMENTS COPYING INSTALL NEWS README
%doc festdoc-1.4.2/festival/html/*html
%doc festdoc-1.4.2/festival/info
%doc festdoc-1.4.2/festival/festival.ps
# stuff from speech_tools
/usr/bin/align
/usr/bin/bcat
/usr/bin/build_docbook_index
/usr/bin/ch_lab
/usr/bin/ch_track
/usr/bin/ch_utt
/usr/bin/ch_wave
/usr/bin/cxx_to_docbook
/usr/bin/design_filter
/usr/bin/dp
/usr/bin/est_examples
/usr/bin/est_gdb
/usr/bin/est_program
/usr/bin/example_to_doc++
/usr/bin/fringe_client
/usr/bin/make_wagon_desc
/usr/bin/na_play
/usr/bin/na_record
/usr/bin/ngram_build
/usr/bin/ngram_test
/usr/bin/ols
/usr/bin/ols_test
/usr/bin/pda
/usr/bin/pitchmark
/usr/bin/pm
/usr/bin/raw_to_xgraph
/usr/bin/resynth
/usr/bin/scfg_make
/usr/bin/scfg_parse
/usr/bin/scfg_test
/usr/bin/scfg_train
/usr/bin/sig2fv
/usr/bin/sigfilter
/usr/bin/siod
/usr/bin/spectgen
/usr/bin/tex_to_images
/usr/bin/tilt_analysis
/usr/bin/tilt_synthesis
/usr/bin/viterbi
/usr/bin/wagon
/usr/bin/wagon_test
/usr/bin/wfst_build
/usr/bin/wfst_run
/usr/bin/xml_parser
# Actual festival stuff
/usr/bin/festival*
/usr/share/festival
%{_mandir}/man1/*

%files devel
%defattr(-,root,root)
%doc festdoc-1.4.2/speech_tools
/usr/lib/*.a
%dir /usr/include/speech_tools
%dir /usr/include/festival
/usr/include/speech_tools/*
/usr/include/festival/*

%changelog
* Mon Mar 18 2002 Tim Powers <timp@redhat.com>
- rebuilt

* Thu Mar 14 2002 Trond Eivind Glomsrd <teg@redhat.com> 1.4.2-2
- Get rid of CVS directiories in doc dir
- Fix broken symlinks for components from speech_tools

* Wed Mar  6 2002 Trond Eivind Glomsrd <teg@redhat.com>
- 1.4.2
- Lots of fixes to make it build, more needed
- Cleanups
- Update URL
- Fix docs inclusion
- Drop prefix
- Use %%{_tmppath}

* Wed Aug  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Add defattr (Bug #15033)

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix build on current 7.0

* Mon Jul 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- fix build on current 7.0

* Thu Jul  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- FHSify

* Mon Jun 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix build on non-x86

* Sun Apr 22 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- initial packaging
